var RE = {
    isBold: document.queryCommandState('bold'),
    isItalic: document.queryCommandState('italic'),
    isUnderline: document.queryCommandState('underline'),
    isStrikeThrough: document.queryCommandState('strikeThrough')
};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0
};

RE.editor = document.getElementById('editor');

document.addEventListener("selectionchange", function() { RE.backuprange(); });

// Initializations
RE.callback = function() {
    var ranges = [
//         '\ud83c[\udf00-\udfff]',
//         '\ud83d[\udc00-\ude4f]',
//         '\ud83d[\ude80-\udeff]'
    ];

    var oldlen=RE.editor.innerHTML;
    var newlen=RE.editor.innerHTML.replace(new RegExp(ranges.join('|'), 'g'), '');

    if(oldlen!=newlen){
        RE.backuprange();
        RE.editor.innerHTML =  RE.editor.innerHTML.replace(new RegExp(ranges.join('|'), 'g'), '');
        RE.restorerange();
    }
    let html = RE.getHtml();
    if (html === "<br>") {
        //清空编辑器了
        RE.setPlaceholder('请输入正文');
        RE.setHtml('');
    }
    let encodeStr = encodeURI(html)
    //RE.editor.focus();
    //编码之后去掉0宽度分隔符，否则看不到
    encodeStr = encodeStr.replace(/%E2%80%8C/g, '')

    window.location.href = "re-callback://" + encodeStr;
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
}

RE.getHtml = function() {

    var ranges = [
//        '\ud83c[\udf00-\udfff]',
//        '\ud83d[\udc00-\ude4f]',
//        '\ud83d[\ude80-\udeff]'
    ];

    return RE.editor.innerHTML.replace(new RegExp(ranges.join('|'), 'g'), '');
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
    RE.editor.style.paddingLeft = left;
    RE.editor.style.paddingTop = top;
    RE.editor.style.paddingRight = right;
    RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    var selection = window.getSelection();
    if (selection.toString().length > 0) {
        document.execCommand('bold', false, null);
    }else
    {
        if (document.queryCommandState('bold')) {
            document.execCommand('bold', false, null);
            document.execCommand('insertHTML', false, '&zwnj;');
        } else {
            document.execCommand('bold', false, null);
        }
    }
    RE.isBold = document.queryCommandState('bold');
    RE.restoreStyle();
}

RE.setItalic = function() {
    console.log()
    var selection = window.getSelection();
    if (selection.toString().length > 0) {
        document.execCommand('italic', false, null);
    }else
    {
        if (document.queryCommandState('italic')) {
            document.execCommand('italic', false, null);
            document.execCommand('insertHTML', false, '&zwnj;');
        } else {
            document.execCommand('italic', false, null);
        }
    }
    RE.isItalic = document.queryCommandState('italic');
    RE.restoreStyle();
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    var selection = window.getSelection();
    if (selection.toString().length > 0) {
        document.execCommand('strikeThrough', false, null);
    }else
    {
        if (document.queryCommandState('strikeThrough')) {
            document.execCommand('strikeThrough', false, null);
            document.execCommand('insertHTML', false, '&zwnj;');
        } else {
            document.execCommand('strikeThrough', false, null);
        }
    }

    RE.isStrikeThrough = document.queryCommandState('strikeThrough');
    RE.restoreStyle();
}

RE.setUnderline = function() {
    var selection = window.getSelection();
    if (selection.toString().length > 0) {
        document.execCommand('underline', false, null);
    }else
    {
        if (document.queryCommandState('underline')) {
            document.execCommand('underline', false, null);
            document.execCommand('insertHTML', false, '&zwnj;');
        } else {
            document.execCommand('underline', false, null);
        }
    }
    RE.isUnderline = document.queryCommandState('underline');
    RE.restoreStyle();
}

RE.setBullets = function() {
    document.execCommand('InsertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('InsertOrderedList', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}

RE.setHeading = function(heading,b) {
    let hTag = 'h'+heading;
    // console.log(document.queryCommandValue("formatBlock"))
    // if(b && document.queryCommandValue("formatBlock") !== hTag)
    //     document.execCommand('formatBlock', false, hTag);
    // else
    //     document.execCommand('formatBlock', false, '<p>');
    

    var p = getTopParent();
    if(!p){
        if(b)
            document.execCommand('formatBlock', false, hTag);
        else
            document.execCommand('formatBlock', false, 'p');
        return;
    }
    var nodeName = p.nodeName.toLowerCase();
    var np;
    //var range = document.createRange();
    if(nodeName === hTag){
            np = document.createElement("p");
            np.innerHTML = p.innerHTML;
            p.parentNode.replaceChild(np,p);
            focusElement(np);
    }else if(nodeName==="ul"||nodeName==="ol"){
        if(document.queryCommandValue("formatBlock") === hTag){
            document.execCommand("formatBlock",false,"p");
        }else{
            document.execCommand("formatBlock",false, hTag);
            // 在列表中选择设置标题，去掉列表状态
        }
    }else{
        // document.execCommand("formatBlock",false,"blockquote");
        np = document.createElement( hTag );
        np.innerHTML = p.innerHTML;
        p.parentNode.replaceChild(np,p);
        focusElement(np);
    }
}

function focusElement(ele){
    var self = window.getSelection();
    var range = document.createRange();
    // var sp = document.createTextNode(" ");
    // parentNode.appendChild(sp);
    // range.selectNodeContents(ele.parentNode.lastChild);
    range.setStart(ele,1);
    // range.setStartAfter(ele);

    self.removeAllRanges();
    self.addRange(range);
}

function getTopParent(){
    var p = RE.closerParentNode();
    if(!p){
        return null;
    }
    var count = 0;
    while(true){
        if(!p.parentNode){
            return null;
        }
        if(p.parentNode.id==='editor' || count===6){
            break;
        }
        p = p.parentNode;
        count++;

    }
    return p;
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function(b) {
    if(b)
        document.execCommand('formatBlock', false, '<blockquote>');
    else
        document.execCommand('formatBlock', false, '<p>');
}

//插入图片
RE.insertImage = function(url, alt, aid) {
    var html = '<img alt="' + alt + '" aid="' + aid +'" src="' + url + '" style="margin: 16px 0;border-radius: 5px;" /><br/><br/>';
    RE.insertHTML(html);
}

//插入分割线
RE.insertHr = function() {
    var html = '<br/><div style="border-bottom: 0.8px dashed #ccc;"></div><br/>';
    RE.insertHTML(html);
}

RE.insertHTML = function(html) {
    if (RE.currentSelection.startContainer == 0) {
        let content = RE.getHtml();
        content = content +  html;
        RE.setHtml(content);
        RE.callback();
    } else {
        RE.restorerange();
        document.execCommand('insertHTML', false, html);
    }
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
        var el = document.createElement("a");
        el.setAttribute("href", url);
        el.setAttribute("title", title);

        var range = sel.getRangeAt(0).cloneRange();
        range.surroundContents(el);
        sel.removeAllRanges();
        sel.addRange(range);
    }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        RE.currentSelection = {
            "startContainer": range.startContainer,
            "startOffset": range.startOffset,
            "endContainer": range.endContainer,
            "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}
//恢复样式
RE.restoreStyle = function () {
    // isBold 变量和编辑器保持一致
    if(RE.isBold && (document.queryCommandState('bold') === false)) {
        document.execCommand('bold', false, null);
    }
    if(RE.isItalic && (document.queryCommandState('italic') === false )) {
        document.execCommand('italic', false, null);
    }
    if(RE.isUnderline && (document.queryCommandState('underline') === false )) {
        document.execCommand('underline', false, null)
    }
    if(RE.isStrikeThrough && (document.queryCommandState('strikeThrough') === false )) {
        document.execCommand('strikeThrough', false, null)
    }
}

RE.enabledEditingItems = function(e) {
    var items = [];
    RE.restoreStyle()
    if (RE.isBold || document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (RE.isItalic || document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (RE.isUnderline || document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (RE.isStrikeThrough || document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }

    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    if(e && e.which==13){
        items.push("enter");
    }

    var ranges = [
//        '\ud83c[\udf00-\udfff]',
//        '\ud83d[\udc00-\ude4f]',
//        '\ud83d[\ude80-\udeff]'
    ];

    window.location.href = "re-state://" + encodeURI(items.join(','))+"@_@"+encodeURI(RE.getHtml());
}

RE.focusEditor = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();

    // the following was taken from http://stackoverflow.com/questions/1125292/how-to-move-cursor-to-end-of-contenteditable-entity/3866442#3866442
    // and ensures we move the cursor to the end of the editor
    // var editor = $('#editor');
    // var range = document.createRange();
    // range.selectNodeContents(editor.get(0));
    // range.collapse(false);
    // var selection = window.getSelection();
    // selection.removeAllRanges();
    // selection.addRange(range);
    // editor.focus();

}

RE.blurEditor = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    execCommand('removeFormat', false, null);
}

// MARK: - Parent nodes & tags

RE.closerParentNode = function() {

    var parentNode = null;
    var selection = window.getSelection();

    if(selection.rangeCount){
        var range = selection.getRangeAt(0).cloneRange();

        var currentNode = range.commonAncestorContainer;

        while (currentNode) {
            if (currentNode.nodeType == document.ELEMENT_NODE) {
                parentNode = currentNode;
                break;
            }

            currentNode = currentNode.parentElement;
        }
    }

    return parentNode;
};

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("keyup", function(e) {
    //RE.enabledEditingItems(e);
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT || e.which ==8 || e.which == 13) {
        RE.enabledEditingItems(e);
    }
});

RE.editor.addEventListener("click", RE.enabledEditingItems);
RE.editor.addEventListener("touchstart", RE.enabledEditingItems);